package com.baeldung.mongodb;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.annotation.DirtiesContext;
import org.springframework.test.context.junit4.SpringRunner;

import com.baeldung.mongodb.daos.UserRepository;
import com.baeldung.mongodb.models.User;


@RunWith(SpringRunner.class)
@SpringBootTest
@DirtiesContext
public class MongoDbAutoGeneratedFieldIntegrationTest {

    @Autowired
    UserRepository userRepository;

    @Test
    public void contextLoads() {}

    @Test
    public void givenUserObject_whenSave_thenCreateNewUser() {

        User user = new User();
        user.setFirstName("John");
        user.setLastName("Doe");
        user.setEmail("john.doe@example.com");
        userRepository.save(user);

        assertThat(userRepository.findAll().size()).isGreaterThan(0);
    }


}
