## Spring Boot REST

This module contains articles about Spring Boot RESTful APIs.

### Relevant Articles

- [HATEOAS for a Spring REST Service](https://www.baeldung.com/rest-api-discoverability-with-spring)
- [Versioning a REST API](https://www.baeldung.com/rest-versioning)
- [ETags for REST with Spring](https://www.baeldung.com/etags-for-rest-with-spring)
- [Testing REST with multiple MIME types](https://www.baeldung.com/testing-rest-api-with-multiple-media-types)
- [Testing Web APIs with Postman Collections](https://www.baeldung.com/postman-testing-collections)
- [Spring Boot Consuming and Producing JSON](https://www.baeldung.com/spring-boot-json)

### E-book

These articles are part of the Spring REST E-book:

1. [Bootstrap a Web Application with Spring 5](https://www.baeldung.com/bootstraping-a-web-application-with-spring-and-java-based-configuration)
2. [Build a REST API with Spring and Java Config](https://www.baeldung.com/building-a-restful-web-service-with-spring-and-java-based-configuration)
3. [Http Message Converters with the Spring Framework](https://www.baeldung.com/spring-httpmessageconverter-rest)
4. [Spring’s RequestBody and ResponseBody Annotations](https://www.baeldung.com/spring-request-response-body)
5. [Entity To DTO Conversion for a Spring REST API](https://www.baeldung.com/entity-to-and-from-dto-for-a-java-spring-application)
6. [Error Handling for REST with Spring](https://www.baeldung.com/exception-handling-for-rest-with-spring)
7. [REST API Discoverability and HATEOAS](https://www.baeldung.com/restful-web-service-discoverability)
8. [An Intro to Spring HATEOAS](https://www.baeldung.com/spring-hateoas-tutorial)
9. [REST Pagination in Spring](https://www.baeldung.com/rest-api-pagination-in-spring)
10. [Test a REST API with Java](https://www.baeldung.com/integration-testing-a-rest-api)

NOTE:
Since this is a module tied to an e-book, it should not be moved or used to store the code for any further article. 
