## Spring Data REST

This module contains articles about Spring Data REST

### Relevant Articles:
- [Introduction to Spring Data REST](https://www.baeldung.com/spring-data-rest-intro)
- [Guide to Spring Data REST Validators](https://www.baeldung.com/spring-data-rest-validators)
- [Working with Relationships in Spring Data REST](https://www.baeldung.com/spring-data-rest-relationships)
- [AngularJS CRUD Application with Spring Data REST](https://www.baeldung.com/angularjs-crud-with-spring-data-rest)
- [Projections and Excerpts in Spring Data REST](https://www.baeldung.com/spring-data-rest-projections-excerpts)
- [Spring Data REST Events with @RepositoryEventHandler](https://www.baeldung.com/spring-data-rest-events)
- [Customizing HTTP Endpoints in Spring Data REST](https://www.baeldung.com/spring-data-rest-customize-http-endpoints)
- [Spring Boot with SQLite](https://www.baeldung.com/spring-boot-sqlite)
- [Spring Data Web Support](https://www.baeldung.com/spring-data-web-support)

### The Course
The "REST With Spring" Classes: http://bit.ly/restwithspring

# Running the project
The application uses [Spring Boot](http://projects.spring.io/spring-boot/), so it is easy to run. You can start it any of a few ways:
* Run the `main` method from `SpringDataRestApplication`
* Use the Maven Spring Boot plugin: `mvn spring-boot:run`
* Package the application as a JAR and run it using `java -jar intro-spring-data-rest.jar`

# Viewing the running application
To view the running application, visit [http://localhost:8080](http://localhost:8080) in your browser
