## Spring MVC XML

This module contains articles about Spring MVC with XML configuration

### The Course

The "REST With Spring" Classes: http://bit.ly/restwithspring

### Relevant Articles: 

- [Java Session Timeout](https://www.baeldung.com/servlet-session-timeout)
- [Returning Image/Media Data with Spring MVC](https://www.baeldung.com/spring-mvc-image-media-data)
- [Geolocation by IP in Java](https://www.baeldung.com/geolocation-by-ip-with-maxmind)
- [Guide to JavaServer Pages (JSP)](https://www.baeldung.com/jsp)
- [Exploring SpringMVC’s Form Tag Library](https://www.baeldung.com/spring-mvc-form-tags)
- [web.xml vs Initializer with Spring](https://www.baeldung.com/spring-xml-vs-java-config)
- [A Java Web Application Without a web.xml](https://www.baeldung.com/java-web-app-without-web-xml)
- [Validating RequestParams and PathVariables in Spring](https://www.baeldung.com/spring-validate-requestparam-pathvariable)
- [Debugging the Spring MVC 404 “No mapping found for HTTP request” Error](https://www.baeldung.com/spring-mvc-404-error)

## Spring MVC with XML Configuration Example Project

- access a sample jsp page at: `http://localhost:8080/spring-mvc-xml/sample.html`
