## Spring Security MVC Custom

This module contains articles about Spring Security with custom MVC applications

### The Course

The "REST With Spring" Classes: http://github.learnspringsecurity.com

### Relevant Articles: 

- [Spring Security Remember Me](https://www.baeldung.com/spring-security-remember-me)
- [Redirect to different pages after Login with Spring Security](https://www.baeldung.com/spring_redirect_after_login)
- [Changing Spring Model Parameters with Handler Interceptor](https://www.baeldung.com/spring-model-parameters-with-handler-interceptor)
- [Introduction to Spring MVC HandlerInterceptor](https://www.baeldung.com/spring-mvc-handlerinterceptor)
- [Using a Custom Spring MVC’s Handler Interceptor to Manage Sessions](https://www.baeldung.com/spring-mvc-custom-handler-interceptor)
- [A Guide to CSRF Protection in Spring Security](https://www.baeldung.com/spring-security-csrf)
- [How to Manually Authenticate User with Spring Security](https://www.baeldung.com/manually-set-user-authentication-spring-security)

### Build the Project

```
mvn clean install
```
